/*
 * RGB_led_matrix_steuerung_v2.c
 *
 * Created: 25.11.2014 05:31:18
 *  Author: Prophecy


----------------CONNECTION----------------------------

PA0		---		Treiber Kathode ROT 0	(Active High)
PA1		---		Treiber Kathode ROT 1	(Active High)
PA2		---		Treiber Kathode ROT 2	(Active High)
PA3		---		Treiber Kathode ROT 3	(Active High)
PA4		---		Treiber Kathode ROT 4	(Active High)
PA5		---		Treiber Kathode ROT 5	(Active High)
PA6		---		Treiber Kathode ROT 6	(Active High)
PA7		---		Taster

PB0		---		Treiber Kathode Grn 0	(Active High)
PB1		---		Treiber Kathode Grn 1	(Active High)
PB2		---		Treiber Kathode Grn 2	(Active High)
PB3		---		Treiber Kathode Grn 3	(Active High)
PB4		---		Treiber Kathode Grn 4	(Active High)
PB5		---		Treiber Kathode Grn 5	(Active High)
PB6		---		Treiber Kathode Grn 6	(Active High)
PB7		---		NC

PC0		---		Treiber Kathode Blau 0	(Active High)
PC1		---		Treiber Kathode Blau 1	(Active High)
PC2		---		Treiber Kathode Blau 2	(Active High)
PC3		---		Treiber Kathode Blau 3	(Active High)
PC4		---		Treiber Kathode Blau 4	(Active High)
PC5		---		Treiber Kathode Blau 5	(Active High)
PC6		---		Treiber Kathode Blau 6	(Active High)
PC7		---		NC

PD0		---		UART RXD
PD1		---		Treiber gemeinsame Anoden 0 (Active LOW)
PD2		---		Treiber gemeinsame Anoden 1 (Active LOW)
PD3		---		Treiber gemeinsame Anoden 2 (Active LOW)
PD4		---		Treiber gemeinsame Anoden 3 (Active LOW)
PD5		---		Treiber gemeinsame Anoden 4 (Active LOW)
PD6		---		Treiber gemeinsame Anoden 5 (Active LOW)
PD7		---		Treiber gemeinsame Anoden 6 (Active LOW)

----------------CONNECTION----------------------------
 */ 



#define F_CPU 24500000UL
#include <avr/io.h>
#include <avr/interrupt.h>

#include "main.h"
#include <util/delay.h>
#include "global.h"



void rainbow(void){
	static uint16_t hue=0;
	static uint8_t column=0;
	
	hue+=2;if(hue > 360) hue=0; if (++column >= columns) column=0;		 set_column_hue(hue, column);
	
}

ISR (TIMER0_OVF_vect){	//93,46 hz ~10ms
	
	static uint8_t ct0=0,second=0;
	
	if (status_flags.not_over_sound_limit){
		ct0++;
		if (ct0 > 93){
			ct0=0;
			second++;
			if (second > max_seconds)	status_flags.screensaver=1;
		}
		
	}else{
		ct0=0;
		second=0;
		status_flags.screensaver=0;
	}
	
	
}

int main(void)
{
	
	DDRA = 0b01111111;
	DDRB = 0b01111111;
	DDRC = 0b01111111;
	DDRD = 0b11111110;
	
	PORTA = 0b10000000;
	PORTB = 0b10000000;
	PORTC = 0b10000000;
	PORTD = 0b11111110;

	row_active = 1;
	higher_bits_flag = 1;
	RandomH=0x13;
	RandomL=0x84;
	
	
	TIMSK	|= _BV(OCIE1A) | _BV(OCIE1B) | _BV(TOIE0);	//Output compare Match A and B, Timer0 Overflow Interrupt enable
	TCCR1B	|= _BV(CS10)   | _BV(WGM12);	//timer1 - CTC mode - Prescaler 1
	TCCR0   |= _BV(CS02)   | _BV(CS00);		//Timer0 prescaler 1024
	
	
	OCR1A	= 12285;
	init_matrix_data(); 	




	sei();
		
		
    while(1)
    {
		
		set_matrix_rgb(0,0,0);
		set_row_hue(100,0);
		BAM_set();
		_delay_ms(2000);
		
		set_matrix_rgb(0,0,0);
		set_row_hue(100,1);
		BAM_set();
		_delay_ms(2000);

		set_matrix_rgb(0,0,0);
		set_row_hue(100,2);
		BAM_set();
		_delay_ms(2000);
		
				set_matrix_rgb(0,0,0);
				set_row_hue(100,3);
				BAM_set();
				_delay_ms(2000);
				
						set_matrix_rgb(0,0,0);
						set_row_hue(100,4);
						BAM_set();
						_delay_ms(2000);
						
								set_matrix_rgb(0,0,0);
								set_row_hue(100,5);
								BAM_set();
								_delay_ms(2000);


		set_matrix_rgb(0,0,0);
		set_row_hue(100,6);
		BAM_set();
		_delay_ms(2000);
		
		
    }
	
	
	
}


// bit-zeiten in clock-ticks und summierung
/*

3				3			BIT0
6				9			BIT1
12				21			BIT2
24				45			BIT3
48				93			BIT4
96				189			BIT5
192				381			BIT6
384				765			BIT7
768				1.533		BIT8
1.536			3.069		BIT9
3.072			6.141		BIT10
6.144			12.285		BIT11

*/