/*
 * matrix.c
 *
 * Created: 27.11.2014 12:24:33
 *  Author: Prophecy
 */ 

#include <avr/io.h>
#include "main.h"
#include "global.h"


void init_matrix_data(void){
	
	uint8_t i;
	
	for (i=0; i < BAM_BITS; i++){
		
		BAM_data_red0[i]=0b10000000;
		BAM_data_red1[i]=0b10000000;
		BAM_data_red2[i]=0b10000000;
		BAM_data_red3[i]=0b10000000;
		BAM_data_red4[i]=0b10000000;
		BAM_data_red5[i]=0b10000000;
		BAM_data_red6[i]=0b10000000;
		
		BAM_data_green0[i]=0b10000000;
		BAM_data_green1[i]=0b10000000;
		BAM_data_green2[i]=0b10000000;
		BAM_data_green3[i]=0b10000000;
		BAM_data_green4[i]=0b10000000;
		BAM_data_green5[i]=0b10000000;
		BAM_data_green6[i]=0b10000000;
		
		BAM_data_blue0[i]=0b10000000;
		BAM_data_blue1[i]=0b10000000;
		BAM_data_blue2[i]=0b10000000;
		BAM_data_blue3[i]=0b10000000;
		BAM_data_blue4[i]=0b10000000;
		BAM_data_blue5[i]=0b10000000;
		BAM_data_blue6[i]=0b10000000;
		
	}

}


void set_led_red (uint8_t row, uint8_t column, uint16_t val){
	
	led_brightness_red[row][column] = val;
}
void set_led_green (uint8_t row, uint8_t column, uint16_t val){
	
	led_brightness_green[row][column] = val;
}
void set_led_blue (uint8_t row, uint8_t column, uint16_t val){
	
	led_brightness_blue[row][column] = val;
}

//sets a single led to a RGB colour (valid values = 0 - ((2^BAM_BITS)-1) )
void set_led_rgb(uint8_t row, uint8_t column, uint16_t red, uint16_t green, uint16_t blue)
{
	set_led_red(row, column, red);
	set_led_green(row, column, green);
	set_led_blue(row, column, blue);
}

//
void set_column_hue(uint16_t hue, uint8_t column){
	uint8_t i;
	
	for (i=0;i<rows;i++){
		set_led_hue(i,column,hue);
	}
}

void set_row_hue(uint16_t hue, uint8_t row){
		uint8_t i;
		
		for (i=0;i<columns;i++){
			set_led_hue(row,i,hue);
		}
}


//sets the whole matrix to a RGB colour
void set_matrix_rgb(uint16_t red, uint16_t green, uint16_t blue)
{
	uint8_t ctr1;
	uint8_t ctr2;
	for (ctr2 = 0; ctr2 < rows; ctr2++) {
		for (ctr1 = 0; ctr1 < columns; ctr1++) {
			set_led_rgb(ctr2, ctr1, red, green, blue);
		}
	}
}

//sets a single led to a HUE colour (hue = 0-360)
void set_led_hue(uint8_t row, uint8_t column, uint16_t hue)
{
	// see wikipeda: HSV	//http://bgrins.github.io/TinyColor/
	float S = 100.0, V = 100.0, s = S / 100.0, v =
	V / 100.0, h_i, f, p, q, t, R, G, B;

	hue = hue % 360;
	h_i = hue / 60;
	f = (float)(hue) / 60.0 - h_i;
	p = v * (1 - s);
	q = v * (1 - s * f);
	t = v * (1 - s * (1 - f));

	switch( (uint8_t)h_i )
	{
		case 0:
		R = v; G = t; B = p; break;
		
		case 1:
		R = q; G = v; B = p; break;
		
		case 2:
		R = p; G = v; B = t; break;
		
		case 3:
		R = p; G = q; B = v; break;
		
		case 4:
		R = t; G = p; B = v; break;
		
		default:
		R = v; G = p; B = q; break;
	}

	set_led_rgb(row, column, (uint16_t) (R * (float)(max_brightness)),
	(uint16_t) (G * (float)(max_brightness)),
	(uint16_t) (B * (float)(max_brightness)));
}

/*sets the whole matrix to a HUE colour (hue = 0-360)*/
void set_matrix_hue(uint16_t hue)
{
	uint8_t ctr1;
	uint8_t ctr2;
	for (ctr2 = 0; ctr2 < rows; ctr2++) {
		for (ctr1 = 0; ctr1 < columns; ctr1++) {
			set_led_hue(ctr2, ctr1, hue);
		}
	}
	
}




void set_all_random(void){
	uint16_t random;
	
			uint8_t ctr1;
			uint8_t ctr2;
			
			for (ctr2 = 0; ctr2 < rows; ctr2++) {
				for (ctr1 = 0; ctr1 < columns; ctr1++) {
					
					
			//		random=0;
					
				
		//			asm("rcall	generate_random");
					
// 					random |= (RandomH << 8);
// 					random |= (RandomL & 0xFF);
// 					
					random = prandom();
					
					random %= 361;	//get 0-360 random value
					
				
		
					
					set_led_hue(ctr2, ctr1, random);
				}
			}
		
	
	
		
	
	
}

//bernahme von den temporren bit-wert variablen in die ISR-port daten
void BAM_set()	{
	
	uint8_t tmp_red0[BAM_BITS] = {0b10000000};
	uint8_t tmp_red1[BAM_BITS] = {0b10000000};
	uint8_t tmp_red2[BAM_BITS] = {0b10000000};
	uint8_t tmp_red3[BAM_BITS] = {0b10000000};
	uint8_t tmp_red4[BAM_BITS] = {0b10000000};
	uint8_t tmp_red5[BAM_BITS] = {0b10000000};
	uint8_t tmp_red6[BAM_BITS] = {0b10000000};
	
	uint8_t tmp_green0[BAM_BITS] = {0b10000000};
	uint8_t tmp_green1[BAM_BITS] = {0b10000000};
	uint8_t tmp_green2[BAM_BITS] = {0b10000000};
	uint8_t tmp_green3[BAM_BITS] = {0b10000000};
	uint8_t tmp_green4[BAM_BITS] = {0b10000000};
	uint8_t tmp_green5[BAM_BITS] = {0b10000000};
	uint8_t tmp_green6[BAM_BITS] = {0b10000000};
	
	uint8_t tmp_blue0[BAM_BITS] = {0b10000000};
	uint8_t tmp_blue1[BAM_BITS] = {0b10000000};
	uint8_t tmp_blue2[BAM_BITS] = {0b10000000};
	uint8_t tmp_blue3[BAM_BITS] = {0b10000000};
	uint8_t tmp_blue4[BAM_BITS] = {0b10000000};
	uint8_t tmp_blue5[BAM_BITS] = {0b10000000};
	uint8_t tmp_blue6[BAM_BITS] = {0b10000000};
	
	for (uint8_t row = 0 ; row < rows ; row++){
		
		for (uint8_t column = 0 ; column < columns ; column++){
			
			
			
			for (uint8_t mask = 0; mask < BAM_BITS ; mask++){
				
				
				if (led_brightness_red[row][column] & _BV(mask)){
					
					switch (row){
						case 0: tmp_red0[mask] |= _BV(column);break;
						case 1: tmp_red1[mask] |= _BV(column);break;
						case 2: tmp_red2[mask] |= _BV(column);break;
						case 3: tmp_red3[mask] |= _BV(column);break;
						case 4: tmp_red4[mask] |= _BV(column);break;
						case 5: tmp_red5[mask] |= _BV(column);break;
						case 6: tmp_red6[mask] |= _BV(column);break;
					}
				}
				
				if (led_brightness_green[row][column] & _BV(mask)){
					
					switch (row){
						case 0: tmp_green0[mask] |= _BV(column);break;
						case 1: tmp_green1[mask] |= _BV(column);break;
						case 2: tmp_green2[mask] |= _BV(column);break;
						case 3: tmp_green3[mask] |= _BV(column);break;
						case 4: tmp_green4[mask] |= _BV(column);break;
						case 5: tmp_green5[mask] |= _BV(column);break;
						case 6: tmp_green6[mask] |= _BV(column);break;
					}
				}
				
				if (led_brightness_blue[row][column] & _BV(mask)){
					
					switch (row){
						case 0: tmp_blue0[mask] |= _BV(column);break;
						case 1: tmp_blue1[mask] |= _BV(column);break;
						case 2: tmp_blue2[mask] |= _BV(column);break;
						case 3: tmp_blue3[mask] |= _BV(column);break;
						case 4: tmp_blue4[mask] |= _BV(column);break;
						case 5: tmp_blue5[mask] |= _BV(column);break;
						case 6: tmp_blue6[mask] |= _BV(column);break;
					}
				}
				
			}
		}
		
		
		
	}
	
	
	
	for (uint8_t i=0; i < BAM_BITS; i++){
		
		BAM_data_blue0[i] = tmp_blue0[i];
		BAM_data_blue1[i] = tmp_blue1[i];
		BAM_data_blue2[i] = tmp_blue2[i];
		BAM_data_blue3[i] = tmp_blue3[i];
		BAM_data_blue4[i] = tmp_blue4[i];
		BAM_data_blue5[i] = tmp_blue5[i];
		BAM_data_blue6[i] = tmp_blue6[i];
		
		BAM_data_green0[i] = tmp_green0[i];
		BAM_data_green1[i] = tmp_green1[i];
		BAM_data_green2[i] = tmp_green2[i];
		BAM_data_green3[i] = tmp_green3[i];
		BAM_data_green4[i] = tmp_green4[i];
		BAM_data_green5[i] = tmp_green5[i];
		BAM_data_green6[i] = tmp_green6[i];
		
		BAM_data_red0[i] = tmp_red0[i];
		BAM_data_red1[i] = tmp_red1[i];
		BAM_data_red2[i] = tmp_red2[i];
		BAM_data_red3[i] = tmp_red3[i];
		BAM_data_red4[i] = tmp_red4[i];
		BAM_data_red5[i] = tmp_red5[i];
		BAM_data_red6[i] = tmp_red6[i];
		
	}


}
