
/*
 * multiplex.s
 *
 * Created: 26.11.2014 18:08:48
 *  Author: Prophecy
 */ 

#include <avr/io.h>
#include "main.h"


.macro  delay reg, val                  ;delay 0 .. 770 cycle
.if     \val > 2
        ldi     \reg, \val / 3
1:
        dec     \reg
        brne    1b
.endif
.if     (\val % 3) == 1
        nop
.endif
.if     (\val % 3) == 2
        rjmp    .+0
.endif
.endm


.comm BAM_data_red0, BAM_BITS
.comm BAM_data_green0, BAM_BITS
.comm BAM_data_blue0, BAM_BITS

.comm BAM_data_red1, BAM_BITS
.comm BAM_data_green1, BAM_BITS
.comm BAM_data_blue1, BAM_BITS

.comm BAM_data_red2, BAM_BITS
.comm BAM_data_green2, BAM_BITS
.comm BAM_data_blue2, BAM_BITS

.comm BAM_data_red3, BAM_BITS
.comm BAM_data_green3, BAM_BITS
.comm BAM_data_blue3, BAM_BITS

.comm BAM_data_red4, BAM_BITS
.comm BAM_data_green4, BAM_BITS
.comm BAM_data_blue4, BAM_BITS

.comm BAM_data_red5, BAM_BITS
.comm BAM_data_green5, BAM_BITS
.comm BAM_data_blue5, BAM_BITS

.comm BAM_data_red6, BAM_BITS
.comm BAM_data_green6, BAM_BITS
.comm BAM_data_blue6, BAM_BITS


.comm row_active, 1
.comm higher_bits_flag, 1

.global	TIMER1_COMPA_vect
TIMER1_COMPA_vect:       
		
		push	r23
		push	r13
		push	r16
		in		r16, _SFR_IO_ADDR(SREG)
		push	r14
		push	r15
		push	r17
		push	r18
		push	r19
		push	r20
		push	r21
		push	r22

		ldi		r23,0x80
		out     _SFR_IO_ADDR(BAM_PORT_RED), r23	
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r23
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r23


		lds		r23,row_active


		sbrc	r23,0
		rcall	output_data0
		sbrc	r23,1
		rcall	output_data1
		sbrc	r23,2
		rcall	output_data2
		sbrc	r23,3
		rcall	output_data3
		sbrc	r23,4
		rcall	output_data4
		sbrc	r23,5
		rcall	output_data5
		sbrc	r23,6
		rcall	output_data6

		lsl		r23
		sbrc	r23,7
		ldi		r23,1
		sts		row_active,r23	

		ldi		r17,0x3
		out		_SFR_IO_ADDR(OCR1BH),r17
		ldi		r17,0x02
		out		_SFR_IO_ADDR(OCR1BL),r17
		
		pop		r22
		pop		r21
		pop		r20
		pop		r19
		pop		r18
		pop		r17
		pop		r15
		pop		r14
		out		_SFR_IO_ADDR(SREG),r16
		pop		r16
		pop		r13
		pop		r23

        reti

;-------------------------------------------------------------------------------
.global TIMER1_COMPB_vect
TIMER1_COMPB_vect:                              ;handle upper bits
		push	r17			
		push	r18
		push	r19
		push	r20
		push	r16
		in		r16,_SFR_IO_ADDR(SREG)

		lds		r20, higher_bits_flag

		sbis	_SFR_IO_ADDR(PORTD),1
		rcall	output_data_high0
		sbis	_SFR_IO_ADDR(PORTD),2
		rcall	output_data_high1
		sbis	_SFR_IO_ADDR(PORTD),3
		rcall	output_data_high2
		sbis	_SFR_IO_ADDR(PORTD),4
		rcall	output_data_high3
		sbis	_SFR_IO_ADDR(PORTD),5
		rcall	output_data_high4
		sbis	_SFR_IO_ADDR(PORTD),6
		rcall	output_data_high5
		sbis	_SFR_IO_ADDR(PORTD),7
		rcall	output_data_high6

		in		r18,_SFR_IO_ADDR(OCR1BH)
		in		r17,_SFR_IO_ADDR(OCR1BL)

		clc
		rol		r17
		rol		r18

		out		_SFR_IO_ADDR(OCR1BH),r18
		out		_SFR_IO_ADDR(OCR1BL),r17
		
		inc		r20
		cpi		r20,5
		brne	weiter
		ldi		r20, 1
weiter:	sts		higher_bits_flag, r20
		out		_SFR_IO_ADDR(SREG),r16
		pop		r16
		pop		r20
		pop		r19
		pop		r18
		pop		r17

        reti
;-------------------------------------------------------------------------------

output_data_high0:
		
		cpi		r20,1
		brne	next_000
		lds		r17, BAM_data_red0+8
		lds		r18, BAM_data_green0+8
		lds		r19, BAM_data_blue0+8
		rjmp	next_2

next_000:		
		cpi		r20,2
		brne	next_0
		lds		r17, BAM_data_red0+9
		lds		r18, BAM_data_green0+9
		lds		r19, BAM_data_blue0+9
		rjmp	next_2
next_0:
		cpi		r20,3
		brne	next_1
		lds		r17, BAM_data_red0+10
		lds		r18, BAM_data_green0+10
		lds		r19, BAM_data_blue0+10
		rjmp	next_2
next_1:
		lds		r17, BAM_data_red0+11
		lds		r18, BAM_data_green0+11
		lds		r19, BAM_data_blue0+11
next_2:
		out     _SFR_IO_ADDR(BAM_PORT_RED), r17		
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r18
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r19

ret

output_data_high1:
		
		cpi		r20,1
		brne	next_001
		lds		r17, BAM_data_red1+8
		lds		r18, BAM_data_green1+8
		lds		r19, BAM_data_blue1+8
		rjmp	next_02
next_001:		
		cpi		r20,2
		brne	next_00
		lds		r17, BAM_data_red1+9
		lds		r18, BAM_data_green1+9
		lds		r19, BAM_data_blue1+9
		rjmp	next_02
next_00:
		cpi		r20,3
		brne	next_01
		lds		r17, BAM_data_red1+10
		lds		r18, BAM_data_green1+10
		lds		r19, BAM_data_blue1+10
		rjmp	next_02
next_01:
		lds		r17, BAM_data_red1+11
		lds		r18, BAM_data_green1+11
		lds		r19, BAM_data_blue1+11
		
next_02:
		out     _SFR_IO_ADDR(BAM_PORT_RED), r17		;745
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r18
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r19

ret


output_data_high2:
		cpi		r20,1
		brne	next_001
		lds		r17, BAM_data_red2+8
		lds		r18, BAM_data_green2+8
		lds		r19, BAM_data_blue2+8
		rjmp	next_05
next_002:		
		cpi		r20,2
		brne	next_03
		lds		r17, BAM_data_red2+9
		lds		r18, BAM_data_green2+9
		lds		r19, BAM_data_blue2+9
		rjmp	next_05
next_03:
		cpi		r20,3
		brne	next_04
		lds		r17, BAM_data_red2+10
		lds		r18, BAM_data_green2+10
		lds		r19, BAM_data_blue2+10
		rjmp	next_05
next_04:
		lds		r17, BAM_data_red2+11
		lds		r18, BAM_data_green2+11
		lds		r19, BAM_data_blue2+11
next_05:
		out     _SFR_IO_ADDR(BAM_PORT_RED), r17		
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r18
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r19

ret


output_data_high3:
		
		cpi		r20,1
		brne	next_003
		lds		r17, BAM_data_red3+8
		lds		r18, BAM_data_green3+8
		lds		r19, BAM_data_blue3+8
		rjmp	next_08
next_003:		
		cpi		r20,2
		brne	next_06
		lds		r17, BAM_data_red3+9
		lds		r18, BAM_data_green3+9
		lds		r19, BAM_data_blue3+9
		rjmp	next_08
next_06:
		cpi		r20,3
		brne	next_07
		lds		r17, BAM_data_red3+10
		lds		r18, BAM_data_green3+10
		lds		r19, BAM_data_blue3+10
		rjmp	next_08
next_07:
		lds		r17, BAM_data_red3+11
		lds		r18, BAM_data_green3+11
		lds		r19, BAM_data_blue3+11
next_08:
		out     _SFR_IO_ADDR(BAM_PORT_RED), r17		
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r18
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r19

ret


output_data_high4:
		
		cpi		r20,1
		brne	next_004
		lds		r17, BAM_data_red4+8
		lds		r18, BAM_data_green4+8
		lds		r19, BAM_data_blue4+8
		rjmp	next_11
next_004:		
		cpi		r20,2
		brne	next_09
		lds		r17, BAM_data_red4+9
		lds		r18, BAM_data_green4+9
		lds		r19, BAM_data_blue4+9
		rjmp	next_11
next_09:
		cpi		r20,3
		brne	next_10
		lds		r17, BAM_data_red4+10
		lds		r18, BAM_data_green4+10
		lds		r19, BAM_data_blue4+10
		rjmp	next_11
next_10:
		lds		r17, BAM_data_red4+11
		lds		r18, BAM_data_green4+11
		lds		r19, BAM_data_blue4+11
next_11:
		out     _SFR_IO_ADDR(BAM_PORT_RED), r17		
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r18
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r19

ret


output_data_high5:
		cpi		r20,1
		brne	next_005
		lds		r17, BAM_data_red5+8
		lds		r18, BAM_data_green5+8
		lds		r19, BAM_data_blue5+8
		rjmp	next_14
next_005:		
		cpi		r20,2
		brne	next_12
		lds		r17, BAM_data_red5+9
		lds		r18, BAM_data_green5+9
		lds		r19, BAM_data_blue5+9
		rjmp	next_14
next_12:
		cpi		r20,3
		brne	next_13
		lds		r17, BAM_data_red5+10
		lds		r18, BAM_data_green5+10
		lds		r19, BAM_data_blue5+10
		rjmp	next_14
next_13:
		lds		r17, BAM_data_red5+11
		lds		r18, BAM_data_green5+11
		lds		r19, BAM_data_blue5+11
next_14:
		out     _SFR_IO_ADDR(BAM_PORT_RED), r17		
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r18
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r19

ret


output_data_high6:
		cpi		r20,1
		brne	next_006
		lds		r17, BAM_data_red6+8
		lds		r18, BAM_data_green6+8
		lds		r19, BAM_data_blue6+8
		rjmp	next_17
next_006:		
		cpi		r20,2
		brne	next_15
		lds		r17, BAM_data_red6+9
		lds		r18, BAM_data_green6+9
		lds		r19, BAM_data_blue6+9
		rjmp	next_17
next_15:
		cpi		r20,3
		brne	next_16
		lds		r17, BAM_data_red6+10
		lds		r18, BAM_data_green6+10
		lds		r19, BAM_data_blue6+10
		rjmp	next_17
next_16:
		lds		r17, BAM_data_red6+11
		lds		r18, BAM_data_green6+11
		lds		r19, BAM_data_blue6+11
next_17:
		out     _SFR_IO_ADDR(BAM_PORT_RED), r17		
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r18
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r19

ret


output_data0:
		
		lds		r13, BAM_data_red0
		lds		r14, BAM_data_green0
		lds		r15, BAM_data_blue0
		lds		r17, BAM_data_red0+1
		lds		r18, BAM_data_green0+1
		lds		r19, BAM_data_blue0+1
		lds		r20, BAM_data_red0+2
		lds		r21, BAM_data_green0+2
		
		sbi		_SFR_IO_ADDR(PORTD), 7
		cbi		_SFR_IO_ADDR(PORTD), 1

		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15
		out     _SFR_IO_ADDR(BAM_PORT_RED), r17		;3 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r18
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r19
		
		

		lds		r22, BAM_data_blue0+2
		nop

 		out     _SFR_IO_ADDR(BAM_PORT_RED), r20		;6 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r21
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r22

		lds		r13, BAM_data_red0+3
		lds		r14, BAM_data_green0+3
		lds		r15, BAM_data_blue0+3
		
		lpm		r22, z

		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;12 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15

		lds		r13, BAM_data_red0+4
		lds		r14, BAM_data_green0+4
		lds		r15, BAM_data_blue0+4


		delay	r17,15

		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;24 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15

		lds		r13, BAM_data_red0+5
		lds		r14, BAM_data_green0+5
		lds		r15, BAM_data_blue0+5

		delay	r17,39


		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;48 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15

		lds		r13, BAM_data_red0+6
		lds		r14, BAM_data_green0+6
		lds		r15, BAM_data_blue0+6
		
		delay	r17,87

		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;96 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15

		lds		r13, BAM_data_red0+7
		lds		r14, BAM_data_green0+7
		lds		r15, BAM_data_blue0+7
		
		delay	r17,183

		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;192 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15


ret



output_data1:
		
		lds		r13, BAM_data_red1
		lds		r14, BAM_data_green1
		lds		r15, BAM_data_blue1
		lds		r17, BAM_data_red1+1
		lds		r18, BAM_data_green1+1
		lds		r19, BAM_data_blue1+1
		lds		r20, BAM_data_red1+2
		lds		r21, BAM_data_green1+2
		

		sbi		_SFR_IO_ADDR(PORTD), 1
		cbi		_SFR_IO_ADDR(PORTD), 2


		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15
		out     _SFR_IO_ADDR(BAM_PORT_RED), r17		;3 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r18
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r19
			
		lds		r22, BAM_data_blue1+2
		nop

		out     _SFR_IO_ADDR(BAM_PORT_RED), r20		;6 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r21
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r22

		lds		r13, BAM_data_red1+3
		lds		r14, BAM_data_green1+3
		lds		r15, BAM_data_blue1+3
		
		lpm		r22, z

		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;12 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15

		lds		r13, BAM_data_red1+4
		lds		r14, BAM_data_green1+4
		lds		r15, BAM_data_blue1+4

	
		delay	r17,15

		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;24 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15

		lds		r13, BAM_data_red1+5
		lds		r14, BAM_data_green1+5
		lds		r15, BAM_data_blue1+5

		delay	r17,39


		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;48 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15

		lds		r13, BAM_data_red1+6
		lds		r14, BAM_data_green1+6
		lds		r15, BAM_data_blue1+6
		
		delay	r17,87

		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;96 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15

		lds		r13, BAM_data_red1+7
		lds		r14, BAM_data_green1+7
		lds		r15, BAM_data_blue1+7
		
		delay	r17,183

		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;192 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15


ret


output_data2:
		
		lds		r13, BAM_data_red2
		lds		r14, BAM_data_green2
		lds		r15, BAM_data_blue2
		lds		r17, BAM_data_red2+1
		lds		r18, BAM_data_green2+1
		lds		r19, BAM_data_blue2+1
		lds		r20, BAM_data_red2+2
		lds		r21, BAM_data_green2+2
		

		
		sbi		_SFR_IO_ADDR(PORTD), 2
		cbi		_SFR_IO_ADDR(PORTD), 3

		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15
		out     _SFR_IO_ADDR(BAM_PORT_RED), r17		;3 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r18
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r19
		
		
			
		lds		r22, BAM_data_blue2+2
		nop

		out     _SFR_IO_ADDR(BAM_PORT_RED), r20		;6 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r21
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r22

		lds		r13, BAM_data_red2+3
		lds		r14, BAM_data_green2+3
		lds		r15, BAM_data_blue2+3
		
		lpm		r22, z

		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;12 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15

		lds		r13, BAM_data_red2+4
		lds		r14, BAM_data_green2+4
		lds		r15, BAM_data_blue2+4


		delay	r17,15

		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;24 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15

		lds		r13, BAM_data_red2+5
		lds		r14, BAM_data_green2+5
		lds		r15, BAM_data_blue2+5

		delay	r17,39


		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;48 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15

		lds		r13, BAM_data_red2+6
		lds		r14, BAM_data_green2+6
		lds		r15, BAM_data_blue2+6
		
		delay	r17,87

		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;96 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15

		lds		r13, BAM_data_red2+7
		lds		r14, BAM_data_green2+7
		lds		r15, BAM_data_blue2+7
		
		delay	r17,183

		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;192 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15


ret


output_data3:
		
		lds		r13, BAM_data_red3
		lds		r14, BAM_data_green3
		lds		r15, BAM_data_blue3
		lds		r17, BAM_data_red3+1
		lds		r18, BAM_data_green3+1
		lds		r19, BAM_data_blue3+1
		lds		r20, BAM_data_red3+2
		lds		r21, BAM_data_green3+2
		

		sbi		_SFR_IO_ADDR(PORTD), 3
		cbi		_SFR_IO_ADDR(PORTD), 4


		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15
		out     _SFR_IO_ADDR(BAM_PORT_RED), r17		;3 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r18
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r19
			
		lds		r22, BAM_data_blue3+2
		nop

		out     _SFR_IO_ADDR(BAM_PORT_RED), r20		;6 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r21
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r22

		lds		r13, BAM_data_red3+3
		lds		r14, BAM_data_green3+3
		lds		r15, BAM_data_blue3+3
		
		lpm		r22, z

		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;12 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15

		lds		r13, BAM_data_red3+4
		lds		r14, BAM_data_green3+4
		lds		r15, BAM_data_blue3+4


		delay	r17,15

		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;24 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15

		lds		r13, BAM_data_red3+5
		lds		r14, BAM_data_green3+5
		lds		r15, BAM_data_blue3+5

		delay	r17,39


		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;48 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15

		lds		r13, BAM_data_red3+6
		lds		r14, BAM_data_green3+6
		lds		r15, BAM_data_blue3+6
		
		delay	r17,87

		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;96 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15

		lds		r13, BAM_data_red3+7
		lds		r14, BAM_data_green3+7
		lds		r15, BAM_data_blue3+7
		
		delay	r17,183

		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;192 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15



ret



output_data4:
		
		lds		r13, BAM_data_red4
		lds		r14, BAM_data_green4
		lds		r15, BAM_data_blue4
		lds		r17, BAM_data_red4+1
		lds		r18, BAM_data_green4+1
		lds		r19, BAM_data_blue4+1
		lds		r20, BAM_data_red4+2
		lds		r21, BAM_data_green4+2
		
		sbi		_SFR_IO_ADDR(PORTD), 4
		cbi		_SFR_IO_ADDR(PORTD), 5

		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15
		out     _SFR_IO_ADDR(BAM_PORT_RED), r17		;3 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r18
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r19
			
		lds		r22, BAM_data_blue4+2
		nop

		out     _SFR_IO_ADDR(BAM_PORT_RED), r20		;6 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r21
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r22

		lds		r13, BAM_data_red4+3
		lds		r14, BAM_data_green4+3
		lds		r15, BAM_data_blue4+3
	
		lpm		r22, z

		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;12 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15

		lds		r13, BAM_data_red4+4
		lds		r14, BAM_data_green4+4
		lds		r15, BAM_data_blue4+4


		delay	r17,15

		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;24 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15

		lds		r13, BAM_data_red4+5
		lds		r14, BAM_data_green4+5
		lds		r15, BAM_data_blue4+5

		delay	r17,39


		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;48 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15

		lds		r13, BAM_data_red4+6
		lds		r14, BAM_data_green4+6
		lds		r15, BAM_data_blue4+6
		
		delay	r17,87

		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;96 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15

		lds		r13, BAM_data_red4+7
		lds		r14, BAM_data_green4+7
		lds		r15, BAM_data_blue4+7
		
		delay	r17,183

		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;192 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15


ret


output_data5:
		
		lds		r13, BAM_data_red5
		lds		r14, BAM_data_green5
		lds		r15, BAM_data_blue5
		lds		r17, BAM_data_red5+1
		lds		r18, BAM_data_green5+1
		lds		r19, BAM_data_blue5+1
		lds		r20, BAM_data_red5+2
		lds		r21, BAM_data_green5+2
		

		sbi		_SFR_IO_ADDR(PORTD), 5
		cbi		_SFR_IO_ADDR(PORTD), 6

		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15
		out     _SFR_IO_ADDR(BAM_PORT_RED), r17		;3 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r18
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r19
			
		lds		r22, BAM_data_blue5+2
		nop

		out     _SFR_IO_ADDR(BAM_PORT_RED), r20		;6 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r21
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r22

		lds		r13, BAM_data_red5+3
		lds		r14, BAM_data_green5+3
		lds		r15, BAM_data_blue5+3

		lpm		r22, z

		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;12 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15

		lds		r13, BAM_data_red5+4
		lds		r14, BAM_data_green5+4
		lds		r15, BAM_data_blue5+4


		delay	r17,15

		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;24 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15

		lds		r13, BAM_data_red5+5
		lds		r14, BAM_data_green5+5
		lds		r15, BAM_data_blue5+5

		delay	r17,39


		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;48 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15

		lds		r13, BAM_data_red5+6
		lds		r14, BAM_data_green5+6
		lds		r15, BAM_data_blue5+6
		
		delay	r17,87

		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;96 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15

		lds		r13, BAM_data_red5+7
		lds		r14, BAM_data_green5+7
		lds		r15, BAM_data_blue5+7
		
		delay	r17,183

		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;192 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15



ret


output_data6:
		
		lds		r13, BAM_data_red6
		lds		r14, BAM_data_green6
		lds		r15, BAM_data_blue6
		lds		r17, BAM_data_red6+1
		lds		r18, BAM_data_green6+1
		lds		r19, BAM_data_blue6+1
		lds		r20, BAM_data_red6+2
		lds		r21, BAM_data_green6+2
		

		sbi		_SFR_IO_ADDR(PORTD), 6
		cbi		_SFR_IO_ADDR(PORTD), 7


		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15
		out     _SFR_IO_ADDR(BAM_PORT_RED), r17		;3 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r18
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r19
			
		lds		r22, BAM_data_blue6+2
		nop

		out     _SFR_IO_ADDR(BAM_PORT_RED), r20		;6 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r21
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r22

		lds		r13, BAM_data_red6+3
		lds		r14, BAM_data_green6+3
		lds		r15, BAM_data_blue6+3

		lpm		r22, z

		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;12 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15

		lds		r13, BAM_data_red6+4
		lds		r14, BAM_data_green6+4
		lds		r15, BAM_data_blue6+4


		delay	r17,15

		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;24 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15

		lds		r13, BAM_data_red6+5
		lds		r14, BAM_data_green6+5
		lds		r15, BAM_data_blue6+5

		delay	r17,39


		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;48 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15

		lds		r13, BAM_data_red6+6
		lds		r14, BAM_data_green6+6
		lds		r15, BAM_data_blue6+6
		
		delay	r17,87

		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;96 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15

		lds		r13, BAM_data_red6+7
		lds		r14, BAM_data_green6+7
		lds		r15, BAM_data_blue6+7
		
		delay	r17,183

		out     _SFR_IO_ADDR(BAM_PORT_RED), r13		;192 cycle
		out     _SFR_IO_ADDR(BAM_PORT_GREEN), r14
		out     _SFR_IO_ADDR(BAM_PORT_BLUE), r15


		ret